import type { Compiler, NormalModule } from 'webpack';
import { AbstractOperation } from './operations';
export interface Rule {
    test: RegExp | ((module: NormalModule) => boolean);
    operations?: AbstractOperation[];
}
export type Options = {
    debug?: boolean;
    rules: Rule[];
    constants?: Record<string, string | number>;
};
export declare class ModifySourcePlugin {
    protected readonly options: Options;
    constructor(options: Options);
    apply(compiler: Compiler): void;
}
