import { SerializableClassInstance } from '../serializable';
import { AbstractOperation } from './AbstractOperation';
export declare enum ConcatPosition {
    START = "start",
    END = "end"
}
export declare class ConcatOperation extends AbstractOperation {
    readonly position: ConcatPosition;
    readonly value: string;
    SERIALIZABLE_CLASS: string;
    constructor(position: ConcatPosition, value: string);
    toSerializable(): SerializableClassInstance<ConcatOperation>;
    static fromSerializable<TConstants extends Record<string, string | number>>(serializable: SerializableClassInstance<ConcatOperation>, constants?: TConstants): ConcatOperation;
    apply(sourceText: string): string;
}
