"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.ConcatOperation = exports.ConcatPosition = void 0;
var AbstractOperation_1 = require("./AbstractOperation");
var fillConstantsInString_1 = require("./utils/fillConstantsInString");
var ConcatPosition;
(function (ConcatPosition) {
    ConcatPosition["START"] = "start";
    ConcatPosition["END"] = "end";
})(ConcatPosition = exports.ConcatPosition || (exports.ConcatPosition = {}));
var ConcatOperation = /** @class */ (function (_super) {
    __extends(ConcatOperation, _super);
    function ConcatOperation(position, value) {
        var _this = _super.call(this) || this;
        _this.position = position;
        _this.value = value;
        _this.SERIALIZABLE_CLASS = ConcatOperation.name;
        return _this;
    }
    ConcatOperation.prototype.toSerializable = function () {
        return {
            SERIALIZABLE_CLASS: this.SERIALIZABLE_CLASS,
            position: this.position,
            value: this.value
        };
    };
    ConcatOperation.fromSerializable = function (serializable, constants) {
        var value = constants
            ? (0, fillConstantsInString_1.fillConstantsInString)(serializable.value, constants)
            : serializable.value;
        return new ConcatOperation(serializable.position, value);
    };
    ConcatOperation.prototype.apply = function (sourceText) {
        switch (this.position) {
            case ConcatPosition.START:
                return this.value + sourceText;
            case ConcatPosition.END:
                return sourceText + this.value;
        }
    };
    return ConcatOperation;
}(AbstractOperation_1.AbstractOperation));
exports.ConcatOperation = ConcatOperation;
//# sourceMappingURL=ConcatOperation.js.map