import { TextRange, TextLinesRange, TextSection, TextLinesSection } from '../range';
import { SerializableClassInstance } from '../serializable';
import { AbstractOperation } from './AbstractOperation';
export declare enum ReplaceStrategy {
    ALL = "all",
    ONCE = "once"
}
export declare class ReplaceOperation extends AbstractOperation {
    readonly searchValue: string | TextRange | TextLinesRange | TextSection | TextLinesSection;
    readonly replaceValue: string;
    readonly repeatCount: number | ReplaceStrategy;
    SERIALIZABLE_CLASS: string;
    constructor(searchValue: string | TextRange | TextLinesRange | TextSection | TextLinesSection, replaceValue: string, repeatCount?: number | ReplaceStrategy);
    toSerializable(): SerializableClassInstance<ReplaceOperation>;
    static fromSerializable<TConstants extends Record<string, string | number>>(serializable: SerializableClassInstance<ReplaceOperation>, constants?: TConstants): ReplaceOperation;
    apply(sourceText: string): string;
}
