"use strict";
exports.__esModule = true;
exports.operationFromSerializable = void 0;
var operations_1 = require("../operations");
var isSerializableOfClass_1 = require("./isSerializableOfClass");
function operationFromSerializable(serializable, constants) {
    if ((0, isSerializableOfClass_1.isSerializableOfClass)(serializable, operations_1.ReplaceOperation)) {
        return operations_1.ReplaceOperation.fromSerializable(serializable, constants);
    }
    if ((0, isSerializableOfClass_1.isSerializableOfClass)(serializable, operations_1.ConcatOperation)) {
        return operations_1.ConcatOperation.fromSerializable(serializable, constants);
    }
    throw new Error("Incorrect serializable provided: ".concat(JSON.stringify(serializable)));
}
exports.operationFromSerializable = operationFromSerializable;
//# sourceMappingURL=operationFromSerializable.js.map