"use strict";
exports.__esModule = true;
exports.rangeFromSerializable = void 0;
var range_1 = require("../range");
var isSerializableOfClass_1 = require("./isSerializableOfClass");
function rangeFromSerializable(serializable) {
    if ((0, isSerializableOfClass_1.isSerializableOfClass)(serializable, range_1.TextRange)) {
        return range_1.TextRange.fromSerializable(serializable);
    }
    if ((0, isSerializableOfClass_1.isSerializableOfClass)(serializable, range_1.TextLinesRange)) {
        return range_1.TextLinesRange.fromSerializable(serializable);
    }
    if ((0, isSerializableOfClass_1.isSerializableOfClass)(serializable, range_1.TextSection)) {
        return range_1.TextSection.fromSerializable(serializable);
    }
    if ((0, isSerializableOfClass_1.isSerializableOfClass)(serializable, range_1.TextLinesSection)) {
        return range_1.TextLinesSection.fromSerializable(serializable);
    }
    throw new Error("Unknown range serializable ".concat(serializable));
}
exports.rangeFromSerializable = rangeFromSerializable;
//# sourceMappingURL=rangeFromSerializable.js.map